package org.wfc.omada.api.sitesetting.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * QueryUseNativeNetworkOswV2OpenApiVO
 */
@ApiModel(description = "QueryUseNativeNetworkOswV2OpenApiVO")
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:32:19.054+08:00[Asia/Shanghai]")

public class QueryUseNativeNetworkOswV2OpenApiVo   {
  @JsonProperty("page")
  private Integer page;

  @JsonProperty("pageSize")
  private Integer pageSize;

  @JsonProperty("selectType")
  private String selectType;

  @JsonProperty("ids")
  @Valid
  private List<String> ids = null;

  public QueryUseNativeNetworkOswV2OpenApiVo page(Integer page) {
    this.page = page;
    return this;
  }

  /**
   * Start from 1.
   * @return page
  */
  @ApiModelProperty(required = true, value = "Start from 1.")
  @NotNull


  public Integer getPage() {
    return page;
  }

  public void setPage(Integer page) {
    this.page = page;
  }

  public QueryUseNativeNetworkOswV2OpenApiVo pageSize(Integer pageSize) {
    this.pageSize = pageSize;
    return this;
  }

  /**
   * It should be within the range of 1–1000.
   * @return pageSize
  */
  @ApiModelProperty(required = true, value = "It should be within the range of 1–1000.")
  @NotNull


  public Integer getPageSize() {
    return pageSize;
  }

  public void setPageSize(Integer pageSize) {
    this.pageSize = pageSize;
  }

  public QueryUseNativeNetworkOswV2OpenApiVo selectType(String selectType) {
    this.selectType = selectType;
    return this;
  }

  /**
   * selectType should be a value as follows: all: select all; include: include ids; exclude: exclude ids.
   * @return selectType
  */
  @ApiModelProperty(value = "selectType should be a value as follows: all: select all; include: include ids; exclude: exclude ids.")

@Pattern(regexp="all|include|exclude") 
  public String getSelectType() {
    return selectType;
  }

  public void setSelectType(String selectType) {
    this.selectType = selectType;
  }

  public QueryUseNativeNetworkOswV2OpenApiVo ids(List<String> ids) {
    this.ids = ids;
    return this;
  }

  public QueryUseNativeNetworkOswV2OpenApiVo addIdsItem(String idsItem) {
    if (this.ids == null) {
      this.ids = new ArrayList<>();
    }
    this.ids.add(idsItem);
    return this;
  }

  /**
   * List of VLAN and Interface network IDs. The valid network IDs can be obtained from \"Get LAN network list\".
   * @return ids
  */
  @ApiModelProperty(value = "List of VLAN and Interface network IDs. The valid network IDs can be obtained from \"Get LAN network list\".")


  public List<String> getIds() {
    return ids;
  }

  public void setIds(List<String> ids) {
    this.ids = ids;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    QueryUseNativeNetworkOswV2OpenApiVo queryUseNativeNetworkOswV2OpenApiVo = (QueryUseNativeNetworkOswV2OpenApiVo) o;
    return Objects.equals(this.page, queryUseNativeNetworkOswV2OpenApiVo.page) &&
        Objects.equals(this.pageSize, queryUseNativeNetworkOswV2OpenApiVo.pageSize) &&
        Objects.equals(this.selectType, queryUseNativeNetworkOswV2OpenApiVo.selectType) &&
        Objects.equals(this.ids, queryUseNativeNetworkOswV2OpenApiVo.ids);
  }

  @Override
  public int hashCode() {
    return Objects.hash(page, pageSize, selectType, ids);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class QueryUseNativeNetworkOswV2OpenApiVo {\n");
    
    sb.append("    page: ").append(toIndentedString(page)).append("\n");
    sb.append("    pageSize: ").append(toIndentedString(pageSize)).append("\n");
    sb.append("    selectType: ").append(toIndentedString(selectType)).append("\n");
    sb.append("    ids: ").append(toIndentedString(ids)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

